// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

/// user code: right-hand side of explicit ordinary differential equation
template<typename T>
T g(T p, T x, T y); 

/// explicit Euler simulation of differential model  
template<typename T>
T f(T p, T x) {
  // condition
  assert(x>0);
  // integration step size
  T delta_x=x/m; 
  // initial position fixed to zero
  x=0; 
  // initial state fixed to zero
  T y=0; 
  int i=0;
  while (i<m) {
    // explicit Euler step
    y=y+delta_x*g(p,x,y); 
    x=x+delta_x; 
    i=i+1;
  } 
  return y;
}
