// naumann@stce.rwth-aachen.de

#pragma once

#include<cmath>

/// right-hand side of first differential model: fitness improves with fitness (self-fulfilling prophecy ...)
template<typename T> 
T g(T p, T /*x*/, T y) { 
  return p/(y+1); 
}

/// derivative of g wrt. state y required by solution of implicit Euler system using Newton's method
template<typename T>
T dg_dy(T p, T /*x*/, T y) {
  return -p/pow(y+1,2);
}

