// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"

/// linear regression by Householder reflection
template<typename T>
T linear_regression(VT<T> drdp, VT<T> yobs) {
  // conditions
  assert(drdp.size()==nobs);
  assert(drdp.size()==yobs.size());
  // Householder reflection
  VT<T> v=drdp;
  v(0)=v(0)-drdp(0)/fabs(drdp(0))*drdp.norm();
  VT<T> n=yobs-2*v/(v.dot(v))*(v.dot(yobs));
  return n(0)/drdp.norm();
}

