// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"
#include "residual.h"

// variable linear regression method
template<typename T>
T linear_regression(VT<T> drdp, VT<T> yobs);

/// stationary point of objective wrt. model parameter by linear regression
template<typename T>
T fit(T p, VT<T> xobs, VT<T> yobs) {
  // conditions
  assert(xobs.size()==nobs);
  assert(xobs.size()==yobs.size());
  // run linear regression method
  return linear_regression(dr_dp(p,xobs),yobs);
}
