// naumann@stce.rwth-aachen.de

#pragma once

#include "config.h"
#include "residual.h"

// model
template<typename T> 
T f(T p, T x);

// linear regression method (normal equation or Householder)
template<typename T> 
T linear_regression(VT<T> drdp, VT<T> r);

/// stationary point of objective wrt. model parameter by nonlinear regression
template<typename T>
T fit(T p, VT<T> xobs, VT<T> yobs) {
  // conditions
  assert(xobs.size()==nobs);
  assert(xobs.size()==yobs.size());
  T delta_p;
  do {
    // linearization
    delta_p=linear_regression(dr_dp(p,xobs),r(p,xobs,yobs));
    // iterative update
    p=p-delta_p;
  } while (fabs(delta_p)>eps);
  return p;
}
